<?php
/**
 *
 * @category        modules
 * @package         minigallery
 * @author          Ruud Eisinga
 * @link			http://www.allwww.nl/
 * @license         http://www.gnu.org/licenses/gpl.html
 * @platform        WebsiteBaker 2.8.x
 * @requirements    PHP 5.2.2 and higher
 * @version         0.1
 * @lastmodified    17 aug 2011
 *
 */
require('../../config.php');
require_once (WB_PATH.'/framework/functions.php');
require(WB_PATH.'/modules/admin.php');
$update_when_modified = true; 
set_time_limit ( 600 );
$basedir = WB_PATH.MEDIA_DIRECTORY.'/minigallery/';
$pathToFolder = $basedir.$section_id.'/';
$thumbFolder = $pathToFolder.'thumbs/';
$overwrite = true;
$message = '';

if(isset($_POST['section_id'])) {
	$maxsize = intval($_POST['maxsize']);
	$thumbsize = intval($_POST['thumbsize']);
	$class = $admin->add_slashes(strip_tags($_POST['class']));
	$rel = $admin->add_slashes(strip_tags($_POST['rel']));
	$name = $admin->add_slashes(strip_tags($_POST['name']));
	$description = $admin->add_slashes(strip_tags($_POST['description']));
	$addscripts = isset($_POST['addscripts'])?"1":"0";
	$removefirst = isset($_POST['removecur'])?"1":"0";
	
	$query = "UPDATE ".TABLE_PREFIX."mod_minigallery SET 
			`name` = '$name', 
			`description` = '$description', 
			`addscripts` = '$addscripts', 
			`maxsize` = '$maxsize', 
			`thumbsize` = '$thumbsize', 
			`class` = '$class', 
			`rel` = '$rel' 
			WHERE `section_id` = '$section_id'";
	$database->query($query);	

	make_dir($basedir);
	if ($removefirst) {
		rm_full_dir($thumbFolder);
		rm_full_dir($pathToFolder);
	}
	make_dir($pathToFolder);
	make_dir($thumbFolder);
	
	for($count = 1; $count <= 10; $count++) {
		save_upload ( 'image-'.$count, $maxsize , $thumbsize, $pathToFolder, $thumbFolder, $overwrite, $message ) ;
		
		if ($message) {
			echo '<br/>'.$message;
		}
	}
}

// Check if there is a database error, otherwise say successful
if($database->is_error()) {
	$admin->print_error($database->get_error(), $js_back);
} else {
	$admin->print_success($MESSAGE['PAGES']['SAVED'], ADMIN_URL.'/pages/modify.php?page_id='.$page_id);
}

// Print admin footer
$admin->print_footer();

function save_upload ($fieldname, $resize = 0, $thumbsize = 0, $pathToFolder, $thumbFolder, $overwrite = false, &$message) {
	$message = '';
	if(isset($_FILES[$fieldname]['tmp_name']) AND $_FILES[$fieldname]['tmp_name'] != '') {
		$filename = $_FILES[$fieldname]['name'];
		$path_parts = pathinfo($filename);
		$fileext = strtolower($path_parts['extension']);
		$new_filename = $pathToFolder.$filename;
		$thumb_filename = $thumbFolder.$filename;
		
		// Make sure the image is a jpg or png file
		if($fileext != "jpg") {
			$message = "Error: ".$filename. ' is invalid. Only .jpg is allowed!';
			return false;
		}

		if (file_exists($new_filename) && !$overwrite) {
			$message = "Error: ".$filename. ' already exists!';
			return false;
		} else {
			$message = "Saving: ".$filename. '';
			move_uploaded_file($_FILES[$fieldname]['tmp_name'], $new_filename);
			change_mode($new_filename);
			if (file_exists($new_filename)) {
				do_resize ( $new_filename, $new_filename , $resize, $message );
				do_resize ( $new_filename, $thumb_filename , $thumbsize, $message );
				return true;
			}
		}
	}
	return false;
}


function do_resize ($source, $destination, $size, &$message) {
	if(extension_loaded('gd') AND function_exists('imageCreateFromJpeg')) {
		list($original_x, $original_y) = getimagesize($source);
		if ($original_x < $size && $original_y < $size ) { 
			return false;  //Image smaller than resize size
		}
		if ($original_x > $original_y) {
			$new_width = $size;
			$new_height = $original_y*($size/$original_x);
		}
		if ($original_x < $original_y) {
			$new_width = $original_x*($size/$original_y);
			$new_height = $size;
		}
		if ($original_x == $original_y) {
			$new_width = $size;
			$new_height = $size;	
		}
		$message .= ' - resized from '.$original_x.'x'.$original_y.' to '.intval($new_width).'x'.intval($new_height);
		$source = imageCreateFromJpeg($source);
		$dst_img = ImageCreateTrueColor($new_width, $new_height);
		imagecopyresampled($dst_img,$source,0,0,0,0,$new_width,$new_height,$original_x,$original_y);
		imagejpeg($dst_img, $destination);
		imagedestroy($dst_img);
		imagedestroy($source);
		return true;
   } else {
		return false;
   }
}
?>